--Variables globales
local Max = 0;
Guildmate_show = true;
Guildmate_color = true;
Guildmate_location = true;
Guildmate_level = true;
Guildmate_MaxMembers = 50;

--Table des couleurs de class (voir http://wowprogramming.com/utils/xmlbrowser/live/FrameXML/Constants.lua)
local CLASS_COLORS = {
    ["HUNTER"] = "|cffabd473",
    ["WARLOCK"] = "|cff9482c9",
    ["PRIEST"] = "|cffffffff",
    ["PALADIN"] = "|cfff58cba",
    ["MAGE"] = "|cff69ccf0",
    ["ROGUE"] = "|cfffff569",
    ["DRUID"] = "|cffff7d0a",
    ["SHAMAN"] = "|cff0070de",
    ["WARRIOR"] = "|cffc79c6e",
    ["DEATHKNIGHT"] = "|cffc41f3b",
    ["MONK"] = "|cff00ff96" ,
	["DEMONHUNTER"] = "|cffa330c9" ,
	["DEFAULT"] = "|cffffffff" ,
};

--Affiche un message dans le chat général
local function Guildmate_Message(text)
	DEFAULT_CHAT_FRAME:AddMessage("|cff009900[Guildmate] |r"..text);
end

--Executée au chargement de l'addon
function Guildmate_OnLoad(self)
	--Déclaration des commandes slash
	SLASH_GUILDMATE1 = "/guildmate";
	SLASH_GUILDMATE2 = "/gmate";
	SlashCmdList["GUILDMATE"] = Guildmate_SlashCommand;
	Guildmate_Message(GUILDMATE_ADDONLOADDED);
	self:RegisterEvent("GUILD_ROSTER_UPDATE");
end

--Calcul du nombre de membres connectés
function Guildmate_Update(self)
	--Récupération de la liste des membres connectés
	Max, Cnx, _ = GetNumGuildMembers();
	if(Cnx > 1) then
		local nb = Cnx-1;
		if nb > 999 then nb = "1k+" end;
		Guildmate_Frame_Text:SetText(nb);	-- on retire le joueur en cours
	else
		Guildmate_Frame_Text:SetText("");
	end
end

function Guildmate_OnUpdate(self)
	-- On met à jour la liste des membres
	--Procédure WoW de mise à jour de la liste des membres
	GuildRoster();
	--Procédure de l'addon de mise en forme
	Guildmate_GuildMicroButtonTooltip();
end

--Executée sur capture d'un evenement par le client
function Guildmate_OnEvent(self, event,...)
	--Si la liste des membres a évolué on update (limitation : Maj toutes les  sec. par le serveur)
	if event=="GUILD_ROSTER_UPDATE" and  Guildmate_show == true then
		Guildmate_Update(self);
	end
end

--Mise à jour de l'affichage dans l'info-bulle
function Guildmate_GuildMicroButtonTooltip()
	list = MicroButtonTooltipText(GUILD, "TOGGLEGUILDTAB");
	--Selon le parametrage on affiche ou non les noms
	if Guildmate_show == true then
		--Compteur de nom, si > 50 alors on stop, limitation à 50 nom affichés
		local Compteur = 0;
		local Nom = ""
		local bPremierMembre = true;
		local player = GetUnitName("player",true).."-"..GetRealmName();
		local color = CLASS_COLORS["DEFAULT"];
		local niveau = ""
		local region = ""
		--On affiche que les 50 premiers noms
		for i=1 , Max do
			local name, _, _, level, class, zone, _, _, online, _, classFileName  = GetGuildRosterInfo(i);
			--On affiche que les membres en ligne
			local test ="Online=0";
			if online == true then test = "Online = 1" end;
			if online == true and name ~= player then
				-- Incrémentation du compteur
				Compteur = Compteur + 1;
				--Si compteur = 50 on stop la boucle
				if Compteur == Guildmate_MaxMembers then
					Max=i;
				end
				--Gestion de l'interligne entre Guilde et le premier nom
				if bPremierMembre==true then
					list = list.."\n";
					bPremierMembre = false;
				end
				--Affichage du nom coloré ou pas
				if Guildmate_color then color = CLASS_COLORS[string.upper(classFileName )] end;
				if Guildmate_level then niveau = " ["..level.."]" end ;
				if Guildmate_location then
					if zone == nil then zone = "???"end;
					region = " ("..zone..")";
				end
				Nom = color..name..niveau.."|r"..region;
				--Ajout du nom à la liste
				list = list.."\n"..Nom;
			end
		end
	end
	GuildMicroButton.tooltipText = list;
end

--Gestion des commandes
function Guildmate_SlashCommand(msg)
	--On passe la chaine reçu en minuscule pour ne pas avoir à gérer la casse
	msg = string.lower(msg);
	--On déclare un tableau dans lequel nous allons décomposer la ligne de commande, le message est ce qui suit la commande slash
	args = {};
	for word in string.gmatch(msg, "[^%s]+") do
		table.insert(args, word);
	end
	--Si on a au moins un argument alors on l'analyse et s'il est valide, on exécute la commande demandée
	if args[1] then
		if args[1]=="toggle" then
			Guildmate_show = not Guildmate_show;
			if Guildmate_show then
				Guildmate_Message(GUILDMATE_TOOLTIP_ON);
			else
				Guildmate_Message(GUILDMATE_TOOLTIP_OFF);
			end
		elseif args[1]=="about" then
			Guildmate_About();
		elseif args[1]=="color" then
			Guildmate_color = not Guildmate_color
			if Guildmate_color then
				Guildmate_Message(GUILDMATE_COLOR_ON);
			else
				Guildmate_Message(GUILDMATE_COLOR_OFF);
			end
		elseif args[1]=="loc" then
			Guildmate_location = not Guildmate_location;
			if Guildmate_location then
				Guildmate_Message(GUILDMATE_LOC_ON);
			else
				Guildmate_Message(GUILDMATE_LOC_OFF);
			end
		elseif args[1]=="level" then
			Guildmate_level = not Guildmate_level;
			if Guildmate_level then
				Guildmate_Message(GUILDMATE_LEVEL_ON);
			else
				Guildmate_Message(GUILDMATE_LEVEL_OFF);
			end
		elseif args[1]=="conf" then
			InterfaceOptionsFrame_OpenToCategory("Guildmate");
		else
			Guildmate_Message(GUILDMATE_NOCOMMAND);
		end
	else
		--Dans le cas où aucun argument n'est saisi, on affiche l'aide de la commande slash
		local GUILDMATE_USAGE = string.gsub(GUILDMATE_USAGE,"x","|cffff0000"..GUILDMATE_COMMAND.."|r");
		Guildmate_Message(GUILDMATE_USAGE);
		Guildmate_Message("|cffff0000toggle |r- " ..GUILDMATE_TOGGLE);
		Guildmate_Message("|cffff0000color |r- "..GUILDMATE_COLOR);
		Guildmate_Message("|cffff0000loc |r "..GUILDMATE_LOC);
		Guildmate_Message("|cffff0000about |r- "..GUILDMATE_ABOUT);
		Guildmate_Message("|cffff0000level |r- "..GUILDMATE_LEVEL);
		Guildmate_Message("|cffff0000level |r- "..GUILDMATE_CONF);
	end
end

--About de l'addon
function Guildmate_About()
	Guildmate_Message(GUILDMATE_TITLE..GetAddOnMetadata("Guildmate","Title"));
	Guildmate_Message(GUILDMATE_AUTHOR..GetAddOnMetadata("Guildmate","Author"));
	Guildmate_Message(GUILDMATE_VERSION..GetAddOnMetadata("Guildmate","Version"));
end
